Subject: Apache 1.3: ssl_mutex_on failure and SEGV

From: Bernd Becker <[email-masked]>
Date: Mon, 15 Jul 2002 10:33:20 +0200

Hi,

on a machine running UnixWare 7.1.1 I have been observing the following in
error_log:
[12:13:00 2002] [warn] Failed to acquire global mutex lock
[12:13:00 2002] [warn] Failed to acquire global mutex lock
[12:13:00 2002] [warn] Failed to acquire global mutex lock
[12:13:17 2002] [notice] child pid 24071 exit signal Segmentation fault (11)

I am quite sure this is coming from the mod_ssl module
(with shared memory session cache shmht).

truss says the following:
...
fcntl(19, F_SETLKW, 0x08160110)                 Err#46 ENOLCK
...
where fd 19 seems to be /var/apache/run/ssl_mutex.<PID>

There are no more record locks available (too many file segments locked)
because the system maximum has been exceeded (quote from man fcntl).
Apache is not the culprit for the system running out of locks, but I
wanted to ask this question anyway:

there is no checking of the return code of ssl_mutex_on(), so I assume the 
session
cache in memory is being trashed by concurrent write operations, leading to 
the
SEGV. Shouldn't this be checked and e.g. the session cache not be used in 
such a
case (or some other error handling) ?

Regards,
Bernd
---
Bernd Becker

______________________________________________________________________
Apache Interface to OpenSSL (mod_ssl)                   www.modssl.org
User Support Mailing List                      [email-masked]
Automated List Manager                            [email-masked]